Imports Microsoft.VisualBasic
#Region "Copyright Syncfusion Inc. 2001 - 2006"
'
'  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.ComponentModel

Namespace UndoRedoSample

	''' <summary>
	''' Summary description for Form1.
	''' </summary>
	Public Class Form1
		Inherits System.Windows.Forms.Form
		#Region "members"
		Private gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
		Private mainMenu1 As System.Windows.Forms.MainMenu
		Private WithEvents EditUndo As System.Windows.Forms.MenuItem
		Private WithEvents EditRedo As System.Windows.Forms.MenuItem
		Private EditClear As System.Windows.Forms.MenuItem
		Private EditTransactions As System.Windows.Forms.MenuItem
		Private WithEvents EditClearUndo As System.Windows.Forms.MenuItem
		Private WithEvents EditClearRedo As System.Windows.Forms.MenuItem
		Private WithEvents EditTransactionsBegin As System.Windows.Forms.MenuItem
		Private WithEvents EditTransactionsCommit As System.Windows.Forms.MenuItem
		Private WithEvents EditTransactionsRollBack As System.Windows.Forms.MenuItem
		Private listBox1 As System.Windows.Forms.ListBox
		Private listBox2 As System.Windows.Forms.ListBox

		'needed to conditionally display new stacks
		Private oldRedoCount As Integer
		Private oldUndoCount As Integer
		Private WithEvents editMenu As System.Windows.Forms.MenuItem

		#End Region
		Private WithEvents toolBar1 As System.Windows.Forms.ToolBar
		Private toolBarUndo As System.Windows.Forms.ToolBarButton
		Private toolBarRedo As System.Windows.Forms.ToolBarButton
		Private toolSeparator As System.Windows.Forms.ToolBarButton
		Private toolBeginTrans As System.Windows.Forms.ToolBarButton
		Private toolCommitTrans As System.Windows.Forms.ToolBarButton
		Private toolRollBack As System.Windows.Forms.ToolBarButton
		Private imageList1 As System.Windows.Forms.ImageList
		Private menuItem1 As System.Windows.Forms.MenuItem
		Private WithEvents menuHelp As System.Windows.Forms.MenuItem
		Private panel1 As System.Windows.Forms.Panel
		Private WithEvents menuItem2 As System.Windows.Forms.MenuItem
		Private components As System.ComponentModel.IContainer

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()


			'System.Drawing.Icon ico = new System.Drawing.Icon(GetIconFile(@"common\Images\Grid\Icon\sfgrid.ico"));
			'this.Icon = ico ;
			Me.gridControl1.DefaultRowHeight = 18
			Me.gridControl1.DefaultColWidth = 70
			Me.gridControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue
			Me.gridControl1.Properties.GridLineColor = Color.FromArgb(208, 215, 229)
			Me.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid
			Dim style As GridStyleInfo = Me.gridControl1.BaseStylesMap("Header").StyleInfo
			style.TextColor = System.Drawing.Color.MidnightBlue
			style.Font.Facename = "Verdana"
			style = Me.gridControl1.BaseStylesMap("Standard").StyleInfo
			style.TextColor = System.Drawing.Color.MidnightBlue
			style.Font.Facename = "Verdana"
			Me.BackColor = Color.FromArgb(223, 227, 239)


			'Populate the Grid

			'turn off undo buffer so initial population cannot be undone
			Me.gridControl1.CommandStack.Enabled = False

			'call a routine to populate the grid somehow...
			PopulateMyGrid()
			'turn undo buffer back on...
			Me.gridControl1.CommandStack.Enabled = True

			'handle adding list changes -- handler allows the updating of the display
			AddHandler gridControl1.Invalidated, AddressOf UpdateListBoxes

			oldRedoCount = 0
			oldUndoCount = 0

			Me.gridControl1.RowHeights(0)=0
			Me.gridControl1.ColWidths(0)=0

			Me.gridControl1.TableStyle.BackColor = System.Drawing.Color.FromArgb(218,230,246)
			Me.BackColor = Color.FromArgb(223, 227, 239)
'			this.gridControl1.ActivateCurrentCellBehavior=GridCellActivateAction.ClickOnCell;
'			this.gridControl1.ShowCurrentCellBorderBehavior=GridShowCurrentCellBorder.WhenGridActive;

			AddHandler gridControl1.CellsChanging, AddressOf gridControl1_CellsChanging
		End Sub

		Private Sub gridControl1_CellsChanging(ByVal sender As Object, ByVal e As GridCellsChangingEventArgs)
			Dim range As GridRangeInfo = e.Range
			If range.Left = 2 Then
				Me.gridControl1.CommandStack.Enabled = False
			Else
				Me.gridControl1.CommandStack.Enabled = True
			End If
		End Sub

		Private Function GetIconFile(ByVal bitmapName As String) As String
			For n As Integer = 0 To 9
				If System.IO.File.Exists(bitmapName) Then
					Return bitmapName
				End If

				bitmapName = "..\" & bitmapName
			Next n

			Return bitmapName
		End Function

		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If components IsNot Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub


		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Me.components = New System.ComponentModel.Container()
			Dim gridBaseStyle1 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle2 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle3 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle4 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridCellInfo1 As New Syncfusion.Windows.Forms.Grid.GridCellInfo()
			Dim resources As New System.ComponentModel.ComponentResourceManager(GetType(Form1))
			Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl()
			Me.mainMenu1 = New System.Windows.Forms.MainMenu(Me.components)
			Me.editMenu = New System.Windows.Forms.MenuItem()
			Me.EditUndo = New System.Windows.Forms.MenuItem()
			Me.EditRedo = New System.Windows.Forms.MenuItem()
			Me.EditClear = New System.Windows.Forms.MenuItem()
			Me.EditClearUndo = New System.Windows.Forms.MenuItem()
			Me.EditClearRedo = New System.Windows.Forms.MenuItem()
			Me.EditTransactions = New System.Windows.Forms.MenuItem()
			Me.EditTransactionsBegin = New System.Windows.Forms.MenuItem()
			Me.EditTransactionsCommit = New System.Windows.Forms.MenuItem()
			Me.EditTransactionsRollBack = New System.Windows.Forms.MenuItem()
			Me.menuItem1 = New System.Windows.Forms.MenuItem()
			Me.menuHelp = New System.Windows.Forms.MenuItem()
			Me.menuItem2 = New System.Windows.Forms.MenuItem()
			Me.listBox1 = New System.Windows.Forms.ListBox()
			Me.listBox2 = New System.Windows.Forms.ListBox()
			Me.toolBar1 = New System.Windows.Forms.ToolBar()
			Me.toolBarUndo = New System.Windows.Forms.ToolBarButton()
			Me.toolBarRedo = New System.Windows.Forms.ToolBarButton()
			Me.toolSeparator = New System.Windows.Forms.ToolBarButton()
			Me.toolBeginTrans = New System.Windows.Forms.ToolBarButton()
			Me.toolCommitTrans = New System.Windows.Forms.ToolBarButton()
			Me.toolRollBack = New System.Windows.Forms.ToolBarButton()
			Me.imageList1 = New System.Windows.Forms.ImageList(Me.components)
			Me.panel1 = New System.Windows.Forms.Panel()
			CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
			Me.panel1.SuspendLayout()
			Me.SuspendLayout()
			' 
			' gridControl1
			' 
			Me.gridControl1.AllowDragSelectedCols = True
			Me.gridControl1.AllowDragSelectedRows = True
			Me.gridControl1.AllowDrop = True
			Me.gridControl1.Anchor = (CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles))
			gridBaseStyle1.Name = "Row Header"
			gridBaseStyle1.StyleInfo.BaseStyle = "Header"
			gridBaseStyle1.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left
			gridBaseStyle1.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(System.Drawing.Color.White)
			gridBaseStyle2.Name = "Column Header"
			gridBaseStyle2.StyleInfo.BaseStyle = "Header"
			gridBaseStyle2.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center
			gridBaseStyle3.Name = "Standard"
			gridBaseStyle3.StyleInfo.AllowEnter = False
			gridBaseStyle3.StyleInfo.AutoSize = False
			gridBaseStyle3.StyleInfo.BaseStyle = ""
			gridBaseStyle3.StyleInfo.Borders.Bottom = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame)
			gridBaseStyle3.StyleInfo.Borders.Left = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame)
			gridBaseStyle3.StyleInfo.Borders.Right = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame)
			gridBaseStyle3.StyleInfo.Borders.Top = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame)
			gridBaseStyle3.StyleInfo.CellAppearance = Syncfusion.Windows.Forms.Grid.GridCellAppearance.Flat
			gridBaseStyle3.StyleInfo.CellType = "TextBox"
			gridBaseStyle3.StyleInfo.CellValueType = Nothing
			gridBaseStyle3.StyleInfo.Clickable = True
			gridBaseStyle3.StyleInfo.CultureInfo = Nothing
			gridBaseStyle3.StyleInfo.Description = ""
			gridBaseStyle3.StyleInfo.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Editable
			gridBaseStyle3.StyleInfo.Enabled = True
			gridBaseStyle3.StyleInfo.FloatCell = True
			gridBaseStyle3.StyleInfo.FloodCell = True
			gridBaseStyle3.StyleInfo.Font.Bold = False
			gridBaseStyle3.StyleInfo.Font.Facename = "Verdana"
			gridBaseStyle3.StyleInfo.Font.Italic = False
			gridBaseStyle3.StyleInfo.Font.Size = 8.25F
			gridBaseStyle3.StyleInfo.Font.Strikeout = False
			gridBaseStyle3.StyleInfo.Font.Underline = False
			gridBaseStyle3.StyleInfo.Format = ""
			gridBaseStyle3.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left
			gridBaseStyle3.StyleInfo.HotkeyPrefix = System.Drawing.Text.HotkeyPrefix.Show
			gridBaseStyle3.StyleInfo.ImageList = Nothing
			gridBaseStyle3.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Window)
			gridBaseStyle3.StyleInfo.MaxLength = 0
			gridBaseStyle3.StyleInfo.ReadOnly = False
			gridBaseStyle3.StyleInfo.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show
			gridBaseStyle3.StyleInfo.Text = ""
			gridBaseStyle3.StyleInfo.TextAlign = Syncfusion.Windows.Forms.Grid.GridTextAlign.Default
			gridBaseStyle3.StyleInfo.TextColor = System.Drawing.Color.MidnightBlue
			gridBaseStyle3.StyleInfo.TextMargins.Bottom = 1
			gridBaseStyle3.StyleInfo.TextMargins.Left = 1
			gridBaseStyle3.StyleInfo.TextMargins.Right = 1
			gridBaseStyle3.StyleInfo.TextMargins.Top = 1
			gridBaseStyle3.StyleInfo.Trimming = System.Drawing.StringTrimming.Character
			gridBaseStyle3.StyleInfo.TriState = False
			gridBaseStyle3.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Top
			gridBaseStyle3.StyleInfo.VerticalScrollbar = False
			gridBaseStyle3.StyleInfo.WrapText = True
			gridBaseStyle4.Name = "Header"
			gridBaseStyle4.StyleInfo.Borders.Bottom = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None)
			gridBaseStyle4.StyleInfo.Borders.Left = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None)
			gridBaseStyle4.StyleInfo.Borders.Right = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None)
			gridBaseStyle4.StyleInfo.Borders.Top = New Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None)
			gridBaseStyle4.StyleInfo.CellType = "Header"
			gridBaseStyle4.StyleInfo.Font.Bold = True
			gridBaseStyle4.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb((CInt(Fix((CByte(203))))), (CInt(Fix((CByte(199))))), (CInt(Fix((CByte(184)))))), System.Drawing.Color.FromArgb((CInt(Fix((CByte(238))))), (CInt(Fix((CByte(234))))), (CInt(Fix((CByte(216)))))))
			gridBaseStyle4.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle
			Me.gridControl1.BaseStylesMap.AddRange(New Syncfusion.Windows.Forms.Grid.GridBaseStyle() { gridBaseStyle1, gridBaseStyle2, gridBaseStyle3, gridBaseStyle4})
			Me.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.gridControl1.DefaultColWidth = 70
			Me.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid
			Me.gridControl1.DefaultRowHeight = 18
			Me.gridControl1.DragSelectedCellsMouseButtonsMask = System.Windows.Forms.MouseButtons.None
			gridCellInfo1.Col = -1
			gridCellInfo1.Row = -1
			Me.gridControl1.GridCells.AddRange(New Syncfusion.Windows.Forms.Grid.GridCellInfo() { gridCellInfo1})
			Me.gridControl1.Location = New System.Drawing.Point(256, 40)
			Me.gridControl1.Name = "gridControl1"
			Me.gridControl1.RowCount = 30
			Me.gridControl1.Size = New System.Drawing.Size(360, 368)
			Me.gridControl1.SmartSizeBox = False
			Me.gridControl1.TabIndex = 0
			Me.gridControl1.Text = "gridControl1"
			' 
			' mainMenu1
			' 
			Me.mainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() { Me.editMenu, Me.menuItem1})
			' 
			' editMenu
			' 
			Me.editMenu.Index = 0
			Me.editMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() { Me.EditUndo, Me.EditRedo, Me.EditClear, Me.EditTransactions})
			Me.editMenu.Text = "Edit"
'			Me.editMenu.Popup += New System.EventHandler(Me.editMenu_Popup)
			' 
			' EditUndo
			' 
			Me.EditUndo.Index = 0
			Me.EditUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ
			Me.EditUndo.Text = "Undo"
'			Me.EditUndo.Click += New System.EventHandler(Me.EditUndo_Click)
			' 
			' EditRedo
			' 
			Me.EditRedo.Index = 1
			Me.EditRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY
			Me.EditRedo.Text = "Redo"
'			Me.EditRedo.Click += New System.EventHandler(Me.EditRedo_Click)
			' 
			' EditClear
			' 
			Me.EditClear.Index = 2
			Me.EditClear.MenuItems.AddRange(New System.Windows.Forms.MenuItem() { Me.EditClearUndo, Me.EditClearRedo})
			Me.EditClear.Text = "Clear"
			' 
			' EditClearUndo
			' 
			Me.EditClearUndo.Index = 0
			Me.EditClearUndo.Text = "Undo"
'			Me.EditClearUndo.Click += New System.EventHandler(Me.EditClearUndo_Click)
			' 
			' EditClearRedo
			' 
			Me.EditClearRedo.Index = 1
			Me.EditClearRedo.Text = "Redo"
'			Me.EditClearRedo.Click += New System.EventHandler(Me.EditClearRedo_Click)
			' 
			' EditTransactions
			' 
			Me.EditTransactions.Index = 3
			Me.EditTransactions.MenuItems.AddRange(New System.Windows.Forms.MenuItem() { Me.EditTransactionsBegin, Me.EditTransactionsCommit, Me.EditTransactionsRollBack})
			Me.EditTransactions.Text = "Transactions"
			' 
			' EditTransactionsBegin
			' 
			Me.EditTransactionsBegin.Index = 0
			Me.EditTransactionsBegin.Text = "Begin"
'			Me.EditTransactionsBegin.Click += New System.EventHandler(Me.EditTransactionsBegin_Click)
			' 
			' EditTransactionsCommit
			' 
			Me.EditTransactionsCommit.Index = 1
			Me.EditTransactionsCommit.Text = "Commit"
'			Me.EditTransactionsCommit.Click += New System.EventHandler(Me.EditTransactionsCommit_Click)
			' 
			' EditTransactionsRollBack
			' 
			Me.EditTransactionsRollBack.Index = 2
			Me.EditTransactionsRollBack.Text = "RollBack"
'			Me.EditTransactionsRollBack.Click += New System.EventHandler(Me.EditTransactionsRollBack_Click)
			' 
			' menuItem1
			' 
			Me.menuItem1.Index = 1
			Me.menuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() { Me.menuHelp, Me.menuItem2})
			Me.menuItem1.Text = "Help"
			' 
			' menuHelp
			' 
			Me.menuHelp.Index = 0
			Me.menuHelp.Text = "Help"
'			Me.menuHelp.Click += New System.EventHandler(Me.menuHelp_Click)
			' 
			' menuItem2
			' 
			Me.menuItem2.Index = 1
			Me.menuItem2.Text = "About"
'			Me.menuItem2.Click += New System.EventHandler(Me.menuItem2_Click)
			' 
			' listBox1
			' 
			Me.listBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.listBox1.Location = New System.Drawing.Point(16, 40)
			Me.listBox1.Name = "listBox1"
			Me.listBox1.Size = New System.Drawing.Size(224, 158)
			Me.listBox1.TabIndex = 1
			' 
			' listBox2
			' 
			Me.listBox2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.listBox2.Location = New System.Drawing.Point(16, 208)
			Me.listBox2.Name = "listBox2"
			Me.listBox2.Size = New System.Drawing.Size(224, 171)
			Me.listBox2.TabIndex = 2
			' 
			' toolBar1
			' 
			Me.toolBar1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.toolBar1.Buttons.AddRange(New System.Windows.Forms.ToolBarButton() { Me.toolBarUndo, Me.toolBarRedo, Me.toolSeparator, Me.toolBeginTrans, Me.toolCommitTrans, Me.toolRollBack})
			Me.toolBar1.DropDownArrows = True
			Me.toolBar1.ImageList = Me.imageList1
			Me.toolBar1.Location = New System.Drawing.Point(0, 0)
			Me.toolBar1.Name = "toolBar1"
			Me.toolBar1.ShowToolTips = True
			Me.toolBar1.Size = New System.Drawing.Size(616, 29)
			Me.toolBar1.TabIndex = 3
'			Me.toolBar1.ButtonClick += New System.Windows.Forms.ToolBarButtonClickEventHandler(Me.toolBar1_ButtonClick)
			' 
			' toolBarUndo
			' 
			Me.toolBarUndo.ImageIndex = 0
			Me.toolBarUndo.Name = "toolBarUndo"
			Me.toolBarUndo.ToolTipText = "Undo the last action"
			' 
			' toolBarRedo
			' 
			Me.toolBarRedo.ImageIndex = 1
			Me.toolBarRedo.Name = "toolBarRedo"
			Me.toolBarRedo.ToolTipText = "Redo the last action undone"
			' 
			' toolSeparator
			' 
			Me.toolSeparator.Name = "toolSeparator"
			Me.toolSeparator.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
			' 
			' toolBeginTrans
			' 
			Me.toolBeginTrans.ImageIndex = 2
			Me.toolBeginTrans.Name = "toolBeginTrans"
			Me.toolBeginTrans.ToolTipText = "Begin a transaction"
			' 
			' toolCommitTrans
			' 
			Me.toolCommitTrans.ImageIndex = 3
			Me.toolCommitTrans.Name = "toolCommitTrans"
			Me.toolCommitTrans.ToolTipText = "Commit the transaction"
			' 
			' toolRollBack
			' 
			Me.toolRollBack.ImageIndex = 4
			Me.toolRollBack.Name = "toolRollBack"
			Me.toolRollBack.ToolTipText = "RollBack a transaction"
			' 
			' imageList1
			' 
			Me.imageList1.ImageStream = (CType(resources.GetObject("imageList1.ImageStream"), System.Windows.Forms.ImageListStreamer))
			Me.imageList1.TransparentColor = System.Drawing.Color.Transparent
			Me.imageList1.Images.SetKeyName(0, "")
			Me.imageList1.Images.SetKeyName(1, "")
			Me.imageList1.Images.SetKeyName(2, "")
			Me.imageList1.Images.SetKeyName(3, "")
			Me.imageList1.Images.SetKeyName(4, "")
			' 
			' panel1
			' 
			Me.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.panel1.Controls.Add(Me.gridControl1)
			Me.panel1.Controls.Add(Me.listBox2)
			Me.panel1.Controls.Add(Me.listBox1)
			Me.panel1.Dock = System.Windows.Forms.DockStyle.Fill
			Me.panel1.Location = New System.Drawing.Point(0, 0)
			Me.panel1.Name = "panel1"
			Me.panel1.Size = New System.Drawing.Size(616, 393)
			Me.panel1.TabIndex = 4
			' 
			' Form1
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
			Me.ClientSize = New System.Drawing.Size(616, 393)
			Me.Controls.Add(Me.toolBar1)
			Me.Controls.Add(Me.panel1)
			Me.Menu = Me.mainMenu1
			Me.Name = "Form1"
			Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
			Me.Text = "Undo-Redo Demo"
			CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
			Me.panel1.ResumeLayout(False)
			Me.ResumeLayout(False)
			Me.PerformLayout()

		End Sub
		#End Region

		<STAThread>
		Public Shared Sub Main()
#If SyncfusionFramework1_1 OrElse SyncfusionFramework2_0 Then
			Application.EnableVisualStyles()
#End If
			Application.Run(New Form1())
		End Sub


		#Region "Populate the grid"
		Private Sub PopulateMyGrid()
			'			//used to time things if desired
			'			int startTime = Environment.TickCount;

			'populate with random numbers
			'just place values directly into style, slow but straight-forward
			Dim r As New Random()
			For i As Integer = 1 To Me.gridControl1.RowCount
				For j As Integer = 1 To Me.gridControl1.ColCount
					Me.gridControl1(i,j).CellValue = r.Next(1000)
				Next j
			Next i

			'			//for more efficient population, could use a call to PopulateValues
			'			//for example, this code is more than a factor of ten quicker...
			'			Random r = new Random();
			'			int[,] table = new int[this.gridControl1.RowCount, this.gridControl1.ColCount];
			'			for(int i = 1; i <= this.gridControl1.RowCount; ++i)
			'				for(int j = 1; j <= this.gridControl1.ColCount; ++j)
			'					table[i-1, j-1] = r.Next(1000);
			'
			'			this.gridControl1.PopulateValues(
			'							GridRangeInfo.Cells(1, 1, this.gridControl1.RowCount, this.gridControl1.ColCount),
			'							table); 

			'			MessageBox.Show((Environment.TickCount - startTime).ToString() + " ticks");


		End Sub

		#End Region

		#Region "Menu Handlers"
		Private Sub EditUndo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditUndo.Click
			If Not Me.gridControl1.CommandStack.InTransaction Then
				Me.gridControl1.CommandStack.Undo()
				ShowStacks()
			End If
		End Sub

		Private Sub EditRedo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditRedo.Click
			If Not Me.gridControl1.CommandStack.InTransaction Then
				Me.gridControl1.CommandStack.Redo()
				ShowStacks()
			End If
		End Sub

		Private Sub EditClearUndo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditClearUndo.Click
			If Not Me.gridControl1.CommandStack.InTransaction Then
				Me.gridControl1.CommandStack.UndoStack.Clear()
				ShowStacks()
			End If
		End Sub

		Private Sub EditClearRedo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditClearRedo.Click
			Me.gridControl1.CommandStack.RedoStack.Clear()
			ShowStacks()
		End Sub

		Private Sub EditTransactionsBegin_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditTransactionsBegin.Click
			Me.gridControl1.CommandStack.BeginTrans("Transaction beginning-")
			ShowStacks()
			Me.toolBeginTrans.ImageIndex = 5
		End Sub

		Private Sub EditTransactionsCommit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditTransactionsCommit.Click
			If Me.gridControl1.CommandStack.InTransaction Then
				Me.gridControl1.CommandStack.CommitTrans()
				Me.toolBeginTrans.ImageIndex = 2
				ShowStacks()
			End If
		End Sub

		Private Sub EditTransactionsRollBack_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EditTransactionsRollBack.Click
			If Me.gridControl1.CommandStack.InTransaction Then
				Me.gridControl1.CommandStack.Rollback()
				Me.toolBeginTrans.ImageIndex = 2
				ShowStacks()
			End If
		End Sub
		#End Region

		#Region "Updates to the display lists"

		Private Sub UpdateListBoxes(ByVal sender As Object, ByVal e As InvalidateEventArgs)
			ShowStacks()
		End Sub

		Private Sub ShowStacks()
			ShowRedoStack()
			ShowUndoStack()
		End Sub

		Private Sub ShowUndoStack()
			Dim numUndos As Integer = Me.gridControl1.CommandStack.UndoStack.Count
			If numUndos <> Me.oldUndoCount OrElse Me.gridControl1.CommandStack.InTransaction Then
				Me.listBox1.Items.Clear()
				Me.listBox1.Items.Add(String.Format("{0} Undo items", numUndos))

				If numUndos > 0 OrElse Me.gridControl1.CommandStack.IsRecording Then
					DisplayCommandsInStack(Me.gridControl1.CommandStack.UndoStack.ToArray(), "", listBox1, True)
				End If
				Me.oldUndoCount = numUndos
			End If

		End Sub

		Private Sub ShowRedoStack()
			Dim numRedos As Integer = Me.gridControl1.CommandStack.RedoStack.Count
			If numRedos <> Me.oldRedoCount OrElse Me.gridControl1.CommandStack.InTransaction Then
				Me.listBox2.Items.Clear()
				Me.listBox2.Items.Add(String.Format("{0} Redo items", numRedos))
				If numRedos > 0 OrElse Me.gridControl1.CommandStack.IsRecording Then
					DisplayCommandsInStack(Me.gridControl1.CommandStack.RedoStack.ToArray(), "", listBox2, False)
				End If
				Me.oldRedoCount = numRedos
			End If
		End Sub


		Private Sub DisplayCommandsInStack(ByVal items() As Object, ByVal indent As String, ByVal _listbox As ListBox, ByVal includeCurrentCommand As Boolean)
			Dim s As String
			Dim c As SyncfusionCommand
			Dim tc As GridTransactionCommand
			Dim cutOff As Integer

			'handle the case where we are recording a transaction
			If includeCurrentCommand AndAlso Me.gridControl1.CommandStack.InTransaction Then
				Try
					tc = Me.gridControl1.CommandStack.CurrentTransactionCommand
					DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, False)
				Catch
				End Try
			End If

			For Each o As Object In items
				Try
					c = CType(o, SyncfusionCommand)
					If c IsNot Nothing AndAlso c.Description IsNot Nothing Then
						s = c.Description
					Else
						s = o.ToString()
					End If
					cutOff = 1 + Math.Max(s.LastIndexOf("+"), s.LastIndexOf("."))
					_listbox.Items.Add(indent & s.Substring(cutOff))
				Catch
				End Try

				'check if is a transaction command
				Try
					tc = TryCast(o, GridTransactionCommand)
					If tc IsNot Nothing Then
						DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, False)
					End If
				Catch
				End Try

			Next o


		End Sub

		#End Region

		Private Sub editMenu_Popup(ByVal sender As Object, ByVal e As System.EventArgs) Handles editMenu.Popup
			EditUndo.Enabled = Me.gridControl1.CommandStack.UndoStack.Count > 0
			EditRedo.Enabled = Me.gridControl1.CommandStack.RedoStack.Count > 0

			EditClear.Enabled = EditUndo.Enabled OrElse EditRedo.Enabled
			EditClearUndo.Enabled = EditUndo.Enabled
			EditClearRedo.Enabled = EditRedo.Enabled

			EditTransactionsCommit.Enabled = Me.gridControl1.CommandStack.InTransaction
			EditTransactionsRollBack.Enabled = Me.gridControl1.CommandStack.InTransaction
		End Sub

		Private Sub toolBar1_ButtonClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ToolBarButtonClickEventArgs) Handles toolBar1.ButtonClick
			Select Case e.Button.ImageIndex
				Case 0 'toolBarUndo:
					EditUndo_Click(Me, EventArgs.Empty)
				Case 1 'toolBarRedo:
					EditRedo_Click(Me, EventArgs.Empty)
				Case 2 'toolBeginTrans:
					EditTransactionsBegin_Click(Me, EventArgs.Empty)
				Case 3 'toolCommitTrans:
					EditTransactionsCommit_Click(Me, EventArgs.Empty)
				Case 4 'toolRollBack:
					EditTransactionsRollBack_Click(Me, EventArgs.Empty)
				Case Else
			End Select
		End Sub

		Private Sub menuHelp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles menuHelp.Click
			MessageBox.Show("Change some cells, or move columns or rows in the" & Constants.vbCrLf & "grid. You will see the Undo list start to grow. " & Constants.vbCrLf & Constants.vbCrLf & "Click the Undo button or use the menu to undo an action." & Constants.vbCrLf & " You will see the Redo list change." & Constants.vbCrLf & Constants.vbCrLf & "Use the Begin Transaction to start a group of changes that" & Constants.vbCrLf & "are treated as a single Undo/Redo command. Use Commit " & Constants.vbCrLf & "Transaction to signal the end of a transaction group.")
		End Sub

		Private Sub menuItem2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles menuItem2.Click
			Dim abtForm As New DemoCommon.AboutForm(AppDomain.CurrentDomain.GetAssemblies())
			abtForm.ShowDialog()
		End Sub
	End Class
End Namespace
